import { NgModule, ModuleWithProviders } from '@angular/core';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatCardModule } from '@angular/material/card';
import { CommonModule } from '@angular/common';

import { ReactiveFormsModule } from '@angular/forms';
import { FlexLayoutModule } from '@angular/flex-layout';

import { MatButtonModule } from '@angular/material/button';
import { MatIconModule } from '@angular/material/icon';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatInputModule } from '@angular/material/input';
import { MatFormFieldModule } from '@angular/material/form-field';

import { UCapUiModule } from '@ucap-webmessenger/ui';
import { TranslateModule } from '@ngx-translate/core';

import { DaesangCipherService } from './services/daesang-cipher.service';
import { DaesangProtocolService } from './services/daesang-protocol.service';
import { DaesangApiService } from './services/daesang-api.service';
import { UserListItemComponent } from './components/user-list-item.component';
import { MatRippleModule } from '@angular/material/core';
import { MatCheckboxModule } from '@angular/material/checkbox';

const COMPONENTS = [UserListItemComponent];

const SERVICES = [
  DaesangCipherService,
  DaesangProtocolService,
  DaesangApiService
];

@NgModule({
  imports: [
    CommonModule,
    ReactiveFormsModule,
    FlexLayoutModule,
    MatButtonModule,
    MatFormFieldModule,
    MatIconModule,
    MatInputModule,
    MatRippleModule,
    MatCheckboxModule,
    MatCardModule,
    MatTooltipModule,
    MatProgressSpinnerModule,

    TranslateModule,

    UCapUiModule
  ],
  exports: [...COMPONENTS],
  declarations: [...COMPONENTS]
})
export class UCapDaesangModule {
  public static forRoot(): ModuleWithProviders<UCapDaesangModule> {
    return {
      ngModule: UCapDaesangModule,
      providers: [...SERVICES]
    };
  }
}
